z upgraded to the latest version

This commit is contained in:
Peter Butkovic 2014-06-25 13:20:18 +02:00
commit 6ce9807c6d
3 changed files with 238 additions and 219 deletions

View file

@ -6,7 +6,7 @@ NAME
z - jump around z - jump around
SYNOPSIS SYNOPSIS
z [-chlrt] [regex1 regex2 ... regexn] z [-chlrtx] [regex1 regex2 ... regexn]
AVAILABILITY AVAILABILITY
bash, zsh bash, zsh
@ -18,7 +18,7 @@ DESCRIPTION
directory that matches ALL of the regexes given on the command line. directory that matches ALL of the regexes given on the command line.
OPTIONS OPTIONS
-c restrict matches to subdirectories of the current directory. -c restrict matches to subdirectories of the current directory
-h show a brief help message -h show a brief help message
@ -28,6 +28,8 @@ OPTIONS
-t match by recent access only -t match by recent access only
-x remove the current directory from the datafile
EXAMPLES EXAMPLES
z foo cd to most frecent dir matching foo z foo cd to most frecent dir matching foo
@ -56,7 +58,7 @@ NOTES
Set $_Z_NO_PROMPT_COMMAND to handle PROMPT_COMMAND/precmd your- Set $_Z_NO_PROMPT_COMMAND to handle PROMPT_COMMAND/precmd your-
self. self.
Set $_Z_EXCLUDE_DIRS to an array of directories to exclude. Set $_Z_EXCLUDE_DIRS to an array of directories to exclude.
(These settings should go in .bashrc/.zshrc before the lines (These settings should go in .bashrc/.zshrc before the line
added above.) added above.)
Install the provided man page z.1 somewhere like Install the provided man page z.1 somewhere like
/usr/local/man/man1. /usr/local/man/man1.
@ -68,8 +70,8 @@ NOTES
multiplied by 0.99. Entries with a rank lower than 1 are forgotten. multiplied by 0.99. Entries with a rank lower than 1 are forgotten.
Frecency: Frecency:
Frecency is a portmantaeu of 'recent' and 'frequency'. It is a weighted Frecency is a portmanteau of 'recent' and 'frequency'. It is a weighted
rank that depends on how often and how recently something occured. As rank that depends on how often and how recently something occurred. As
far as I know, Mozilla came up with the term. far as I know, Mozilla came up with the term.
To z, a directory that has low ranking but has been accessed recently To z, a directory that has low ranking but has been accessed recently
@ -107,9 +109,9 @@ ENVIRONMENT
resolving of symlinks. If it is not set, symbolic links will be resolving of symlinks. If it is not set, symbolic links will be
resolved when added to the datafile. resolved when added to the datafile.
In bash, z prepends a command to the PROMPT_COMMAND environment vari- In bash, z appends a command to the PROMPT_COMMAND environment variable
able to maintain its database. In zsh, z appends a function _z_precmd to maintain its database. In zsh, z appends a function _z_precmd to the
to the precmd_functions array. precmd_functions array.
The environment variable $_Z_NO_PROMPT_COMMAND can be set if you want The environment variable $_Z_NO_PROMPT_COMMAND can be set if you want
to handle PROMPT_COMMAND or precmd yourself. to handle PROMPT_COMMAND or precmd yourself.

View file

@ -4,7 +4,7 @@ NAME
z \- jump around z \- jump around
.SH .SH
SYNOPSIS SYNOPSIS
z [\-chlrt] [regex1 regex2 ... regexn] z [\-chlrtx] [regex1 regex2 ... regexn]
.SH .SH
AVAILABILITY AVAILABILITY
bash, zsh bash, zsh
@ -18,7 +18,7 @@ directory that matches ALL of the regexes given on the command line.
OPTIONS OPTIONS
.TP .TP
\fB\-c\fR \fB\-c\fR
restrict matches to subdirectories of the current directory. restrict matches to subdirectories of the current directory
.TP .TP
\fB\-h\fR \fB\-h\fR
show a brief help message show a brief help message
@ -31,6 +31,9 @@ match by rank only
.TP .TP
\fB\-t\fR \fB\-t\fR
match by recent access only match by recent access only
.TP
\fB\-x\fR
remove the current directory from the datafile
.SH EXAMPLES .SH EXAMPLES
.TP 14 .TP 14
\fBz foo\fR \fBz foo\fR
@ -79,7 +82,7 @@ Set \fB$_Z_NO_PROMPT_COMMAND\fR to handle \fBPROMPT_COMMAND/precmd\fR yourself.
Set \fB$_Z_EXCLUDE_DIRS\fR to an array of directories to exclude. Set \fB$_Z_EXCLUDE_DIRS\fR to an array of directories to exclude.
.RE .RE
.RS .RS
(These settings should go in .bashrc/.zshrc before the lines added above.) (These settings should go in .bashrc/.zshrc before the line added above.)
.RE .RE
.RS .RS
Install the provided man page \fBz.1\fR somewhere like \fB/usr/local/man/man1\fR. Install the provided man page \fBz.1\fR somewhere like \fB/usr/local/man/man1\fR.
@ -92,8 +95,8 @@ the sum of ranks is greater than 6000, all ranks are multiplied by 0.99. Entries
with a rank lower than 1 are forgotten. with a rank lower than 1 are forgotten.
.SS .SS
Frecency: Frecency:
Frecency is a portmantaeu of 'recent' and 'frequency'. It is a weighted rank Frecency is a portmanteau of 'recent' and 'frequency'. It is a weighted rank
that depends on how often and how recently something occured. As far as I that depends on how often and how recently something occurred. As far as I
know, Mozilla came up with the term. know, Mozilla came up with the term.
.P .P
To \fBz\fR, a directory that has low ranking but has been accessed recently To \fBz\fR, a directory that has low ranking but has been accessed recently
@ -131,7 +134,7 @@ The environment variable \fB$_Z_NO_RESOLVE_SYMLINKS\fR can be set to prevent
resolving of symlinks. If it is not set, symbolic links will be resolved when resolving of symlinks. If it is not set, symbolic links will be resolved when
added to the datafile. added to the datafile.
.P .P
In bash, \fBz\fR prepends a command to the \fBPROMPT_COMMAND\fR environment In bash, \fBz\fR appends a command to the \fBPROMPT_COMMAND\fR environment
variable to maintain its database. In zsh, \fBz\fR appends a function variable to maintain its database. In zsh, \fBz\fR appends a function
\fB_z_precmd\fR to the \fBprecmd_functions\fR array. \fB_z_precmd\fR to the \fBprecmd_functions\fR array.
.P .P

View file

@ -22,11 +22,6 @@
# * z -l foo # list matches instead of cd # * z -l foo # list matches instead of cd
# * z -c foo # restrict matches to subdirs of $PWD # * z -c foo # restrict matches to subdirs of $PWD
case $- in
*i*) ;;
*) echo 'ERROR: z.sh is meant to be sourced, not directly executed.'
esac
[ -d "${_Z_DATA:-$HOME/.z}" ] && { [ -d "${_Z_DATA:-$HOME/.z}" ] && {
echo "ERROR: z.sh's datafile (${_Z_DATA:-$HOME/.z}) is a directory." echo "ERROR: z.sh's datafile (${_Z_DATA:-$HOME/.z}) is a directory."
} }
@ -35,7 +30,7 @@ _z() {
local datafile="${_Z_DATA:-$HOME/.z}" local datafile="${_Z_DATA:-$HOME/.z}"
# bail out if we don't own ~/.z (we're another user but our ENV is still set) # bail if we don't own ~/.z (we're another user but our ENV is still set)
[ -f "$datafile" -a ! -O "$datafile" ] && return [ -f "$datafile" -a ! -O "$datafile" ] && return
# add entries # add entries
@ -51,10 +46,10 @@ _z() {
[ "$*" = "$exclude" ] && return [ "$*" = "$exclude" ] && return
done done
# maintain the file # maintain the data file
local tempfile local tempfile="$datafile.$RANDOM"
tempfile="$(mktemp "$datafile.XXXXXX")" || return
while read line; do while read line; do
# only count directories
[ -d "${line%%\|*}" ] && echo $line [ -d "${line%%\|*}" ] && echo $line
done < "$datafile" | awk -v path="$*" -v now="$(date +%s)" -F"|" ' done < "$datafile" | awk -v path="$*" -v now="$(date +%s)" -F"|" '
BEGIN { BEGIN {
@ -62,6 +57,7 @@ _z() {
time[path] = now time[path] = now
} }
$2 >= 1 { $2 >= 1 {
# drop ranks below 1
if( $1 == path ) { if( $1 == path ) {
rank[$1] = $2 + 1 rank[$1] = $2 + 1
time[$1] = now time[$1] = now
@ -73,14 +69,16 @@ _z() {
} }
END { END {
if( count > 6000 ) { if( count > 6000 ) {
for( i in rank ) print i "|" 0.99*rank[i] "|" time[i] # aging # aging
} else for( i in rank ) print i "|" rank[i] "|" time[i] for( x in rank ) print x "|" 0.99*rank[x] "|" time[x]
} else for( x in rank ) print x "|" rank[x] "|" time[x]
} }
' 2>/dev/null >| "$tempfile" ' 2>/dev/null >| "$tempfile"
# do our best to avoid clobbering the datafile in a race condition
if [ $? -ne 0 -a -f "$datafile" ]; then if [ $? -ne 0 -a -f "$datafile" ]; then
env rm -f "$tempfile" env rm -f "$tempfile"
else else
env mv -f "$tempfile" "$datafile" env mv -f "$tempfile" "$datafile" || env rm -f "$tempfile"
fi fi
# tab completion # tab completion
@ -89,14 +87,14 @@ _z() {
[ -d "${line%%\|*}" ] && echo $line [ -d "${line%%\|*}" ] && echo $line
done < "$datafile" | awk -v q="$2" -F"|" ' done < "$datafile" | awk -v q="$2" -F"|" '
BEGIN { BEGIN {
if( q == tolower(q) ) nocase = 1 if( q == tolower(q) ) imatch = 1
split(substr(q,3),fnd," ") split(substr(q, 3), fnd, " ")
} }
{ {
if( nocase ) { if( imatch ) {
for( i in fnd ) tolower($1) !~ tolower(fnd[i]) && $1 = "" for( x in fnd ) tolower($1) !~ tolower(fnd[x]) && $1 = ""
} else { } else {
for( i in fnd ) $1 !~ fnd[i] && $1 = "" for( x in fnd ) $1 !~ fnd[x] && $1 = ""
} }
if( $1 ) print $1 if( $1 ) print $1
} }
@ -105,15 +103,16 @@ _z() {
else else
# list/go # list/go
while [ "$1" ]; do case "$1" in while [ "$1" ]; do case "$1" in
--) while [ "$1" ]; do shift; local fnd="$fnd $1";done;; --) while [ "$1" ]; do shift; local fnd="$fnd${fnd:+ }$1";done;;
-*) local opt=${1:1}; while [ "$opt" ]; do case ${opt:0:1} in -*) local opt=${1:1}; while [ "$opt" ]; do case ${opt:0:1} in
c) local fnd="^$PWD $fnd";; c) local fnd="^$PWD $fnd";;
h) echo "${_Z_CMD:-z} [-chlrt] args" >&2; return;; h) echo "${_Z_CMD:-z} [-chlrtx] args" >&2; return;;
x) sed -i -e "\:^${PWD}|.*:d" "$datafile";;
l) local list=1;; l) local list=1;;
r) local typ="rank";; r) local typ="rank";;
t) local typ="recent";; t) local typ="recent";;
esac; opt=${opt:1}; done;; esac; opt=${opt:1}; done;;
*) local fnd="$fnd $1";; *) local fnd="$fnd${fnd:+ }$1";;
esac; local last=$1; shift; done esac; local last=$1; shift; done
[ "$fnd" -a "$fnd" != "^$PWD " ] || local list=1 [ "$fnd" -a "$fnd" != "^$PWD " ] || local list=1
@ -131,59 +130,70 @@ _z() {
[ -d "${line%%\|*}" ] && echo $line [ -d "${line%%\|*}" ] && echo $line
done < "$datafile" | awk -v t="$(date +%s)" -v list="$list" -v typ="$typ" -v q="$fnd" -F"|" ' done < "$datafile" | awk -v t="$(date +%s)" -v list="$list" -v typ="$typ" -v q="$fnd" -F"|" '
function frecent(rank, time) { function frecent(rank, time) {
dx = t-time # relate frequency and time
if( dx < 3600 ) return rank*4 dx = t - time
if( dx < 86400 ) return rank*2 if( dx < 3600 ) return rank * 4
if( dx < 604800 ) return rank/2 if( dx < 86400 ) return rank * 2
return rank/4 if( dx < 604800 ) return rank / 2
return rank / 4
} }
function output(files, toopen, override) { function output(files, out, common) {
# list or return the desired directory
if( list ) { if( list ) {
cmd = "sort -n >&2" cmd = "sort -n >&2"
for( i in files ) if( files[i] ) printf "%-10s %s\n", files[i], i | cmd for( x in files ) {
if( override ) printf "%-10s %s\n", "common:", override > "/dev/stderr" if( files[x] ) printf "%-10s %s\n", files[x], x | cmd
}
if( common ) {
printf "%-10s %s\n", "common:", common > "/dev/stderr"
}
} else { } else {
if( override ) toopen = override if( common ) out = common
print toopen print out
} }
} }
function common(matches) { function common(matches) {
# shortest match # find the common root of a list of matches, if it exists
for( i in matches ) { for( x in matches ) {
if( matches[i] && (!short || length(i) < length(short)) ) short = i if( matches[x] && (!short || length(x) < length(short)) ) {
short = x
}
} }
if( short == "/" ) return if( short == "/" ) return
# shortest match must be common to each match. escape special characters in # use a copy to escape special characters, as we want to return
# a copy when testing, so we can return the original. # the original. yeah, this escaping is awful.
clean_short = short clean_short = short
gsub(/[\(\)\[\]\|]/, "\\\\&", clean_short) gsub(/[\(\)\[\]\|]/, "\\\\&", clean_short)
for( i in matches ) if( matches[i] && i !~ clean_short ) return for( x in matches ) if( matches[x] && x !~ clean_short ) return
return short return short
} }
BEGIN { split(q, a, " "); oldf = noldf = -9999999999 } BEGIN { split(q, words, " "); hi_rank = ihi_rank = -9999999999 }
{ {
if( typ == "rank" ) { if( typ == "rank" ) {
f = $2 rank = $2
} else if( typ == "recent" ) { } else if( typ == "recent" ) {
f = $3-t rank = $3 - t
} else f = frecent($2, $3) } else rank = frecent($2, $3)
wcase[$1] = nocase[$1] = f matches[$1] = imatches[$1] = rank
for( i in a ) { for( x in words ) {
if( $1 !~ a[i] ) delete wcase[$1] if( $1 !~ words[x] ) delete matches[$1]
if( tolower($1) !~ tolower(a[i]) ) delete nocase[$1] if( tolower($1) !~ tolower(words[x]) ) delete imatches[$1]
} }
if( wcase[$1] && wcase[$1] > oldf ) { if( matches[$1] && matches[$1] > hi_rank ) {
cx = $1 best_match = $1
oldf = wcase[$1] hi_rank = matches[$1]
} else if( nocase[$1] && nocase[$1] > noldf ) { } else if( imatches[$1] && imatches[$1] > ihi_rank ) {
ncx = $1 ibest_match = $1
noldf = nocase[$1] ihi_rank = imatches[$1]
} }
} }
END { END {
if( cx ) { # prefer case sensitive
output(wcase, cx, common(wcase)) if( best_match ) {
} else if( ncx ) output(nocase, ncx, common(nocase)) output(matches, best_match, common(matches))
} else if( ibest_match ) {
output(imatches, ibest_match, common(imatches))
}
} }
')" ')"
[ $? -gt 0 ] && return [ $? -gt 0 ] && return
@ -195,9 +205,10 @@ alias ${_Z_CMD:-z}='_z 2>&1'
[ "$_Z_NO_RESOLVE_SYMLINKS" ] || _Z_RESOLVE_SYMLINKS="-P" [ "$_Z_NO_RESOLVE_SYMLINKS" ] || _Z_RESOLVE_SYMLINKS="-P"
if compctl &> /dev/null; then if compctl >/dev/null 2>&1; then
# zsh
[ "$_Z_NO_PROMPT_COMMAND" ] || { [ "$_Z_NO_PROMPT_COMMAND" ] || {
# zsh populate directory list, avoid clobbering any other precmds # populate directory list, avoid clobbering any other precmds.
if [ "$_Z_NO_RESOLVE_SYMLINKS" ]; then if [ "$_Z_NO_RESOLVE_SYMLINKS" ]; then
_z_precmd() { _z_precmd() {
_z --add "${PWD:a}" _z --add "${PWD:a}"
@ -207,22 +218,25 @@ if compctl &> /dev/null; then
_z --add "${PWD:A}" _z --add "${PWD:A}"
} }
fi fi
precmd_functions+=(_z_precmd) [[ -n "${precmd_functions[(r)_z_precmd]}" ]] || {
precmd_functions[$(($#precmd_functions+1))]=_z_precmd
}
} }
# zsh tab completion
_z_zsh_tab_completion() { _z_zsh_tab_completion() {
# tab completion
local compl local compl
read -l compl read -l compl
reply=(${(f)"$(_z --complete "$compl")"}) reply=(${(f)"$(_z --complete "$compl")"})
} }
compctl -U -K _z_zsh_tab_completion _z compctl -U -K _z_zsh_tab_completion _z
elif complete &> /dev/null; then elif complete >/dev/null 2>&1; then
# bash tab completion # bash
# tab completion
complete -o filenames -C '_z --complete "$COMP_LINE"' ${_Z_CMD:-z} complete -o filenames -C '_z --complete "$COMP_LINE"' ${_Z_CMD:-z}
[ "$_Z_NO_PROMPT_COMMAND" ] || { [ "$_Z_NO_PROMPT_COMMAND" ] || {
# bash populate directory list. avoid clobbering other PROMPT_COMMANDs. # populate directory list. avoid clobbering other PROMPT_COMMANDs.
echo $PROMPT_COMMAND | grep -q "_z --add" || { grep "_z --add" <<< "$PROMPT_COMMAND" >/dev/null || {
PROMPT_COMMAND='_z --add "$(pwd '$_Z_RESOLVE_SYMLINKS' 2>/dev/null)" 2>/dev/null;'"$PROMPT_COMMAND" PROMPT_COMMAND="$PROMPT_COMMAND"$'\n''_z --add "$(command pwd '$_Z_RESOLVE_SYMLINKS' 2>/dev/null)" 2>/dev/null;'
} }
} }
fi fi